from Products.CMFCore.utils import getToolByName
from Products.CMFFormController.FormAction import FormActionKey
from Products.Archetypes.Extensions.utils import installTypes
from Products.Archetypes.Extensions.utils import install_subskin
from Products.Archetypes.public import listTypes

from StringIO import StringIO

from Products.CMFDynamicViewFTI.migrate import migrateFTIs

from Products.PloneFacetedClassification.config import *

def installDependencies(portal, out):
    qi = getToolByName(portal, 'portal_quickinstaller')
    for product in DEPENDENCIES:
        if not qi.isProductInstalled(product):
            if qi.isProductInstallable(product):
                qi.installProduct(product)
            else:
                raise "Product %s not installable" % product

def install(self):
    out = StringIO()

    print >> out, "Installing PloneFacetedClassification"

    portal = getToolByName(self, 'portal_url').getPortalObject()   
    # Install dependency products
    installDependencies(portal, out)
    
    # Install types
    classes = listTypes(PROJECTNAME)
    installTypes(self, out,
                 classes,
                 PROJECTNAME)
    print >> out, "Installed types"

    # Install skin
    install_subskin(self, out, product_globals)
    print >> out, "Installed skin"
    
    # Aggiunta delle portal actions
    at=getToolByName(self, 'portal_actions')

    at.addAction('categorie',
                 name='browse',
                 action='string:$portal_url/browse',
                 condition='',
                 permission='View',
                 category='portal_tabs')
                 
    at.addAction('categoria',
                 name='classification',
                 action='string:$object_url/faceted_classification',
                 condition='',
                 permission='View',
                 category='object_tabs')
    
    return out.getvalue()
    
def uninstall(self):
    out = StringIO()
    
    at=getToolByName(self, 'portal_actions')
    
    indice = 0
    indici = []
    cancellate = []
    for action in at.listActions():        
        if action.getId() in ['categoria','categorie']:
            indici.append( indice )
            cancellate.append( action.getId() )
        indice = indice + 1
       
    if len( indici ) != 0:
        at.deleteActions( selections=indici )
    
    out.write('Deleted actions: %s \n' % cancellate )     
    out.write('Uninstallation complete.\n')
    
    return out.getvalue()
